


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/examples/ntlmrelayx/clients/__init__.py: 61%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/examples/ntlmrelayx/clients/__init__.py</b> :
            <span class="pc_cov">61%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            59 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">33 run</span>
            <span class="mis shortkey_m button_toggle_mis">26 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">0 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="stm run hide_run"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="pln"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="pln"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="pln"><a href="#n23">23</a></p>
<p id="n24" class="pln"><a href="#n24">24</a></p>
<p id="n25" class="pln"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="stm run hide_run"><a href="#n27">27</a></p>
<p id="n28" class="stm run hide_run"><a href="#n28">28</a></p>
<p id="n29" class="stm run hide_run"><a href="#n29">29</a></p>
<p id="n30" class="stm mis"><a href="#n30">30</a></p>
<p id="n31" class="stm mis"><a href="#n31">31</a></p>
<p id="n32" class="pln"><a href="#n32">32</a></p>
<p id="n33" class="stm mis"><a href="#n33">33</a></p>
<p id="n34" class="pln"><a href="#n34">34</a></p>
<p id="n35" class="stm mis"><a href="#n35">35</a></p>
<p id="n36" class="pln"><a href="#n36">36</a></p>
<p id="n37" class="stm mis"><a href="#n37">37</a></p>
<p id="n38" class="stm mis"><a href="#n38">38</a></p>
<p id="n39" class="stm mis"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="stm mis"><a href="#n41">41</a></p>
<p id="n42" class="pln"><a href="#n42">42</a></p>
<p id="n43" class="stm run hide_run"><a href="#n43">43</a></p>
<p id="n44" class="stm mis"><a href="#n44">44</a></p>
<p id="n45" class="pln"><a href="#n45">45</a></p>
<p id="n46" class="stm run hide_run"><a href="#n46">46</a></p>
<p id="n47" class="stm mis"><a href="#n47">47</a></p>
<p id="n48" class="pln"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="pln"><a href="#n53">53</a></p>
<p id="n54" class="pln"><a href="#n54">54</a></p>
<p id="n55" class="pln"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="pln"><a href="#n57">57</a></p>
<p id="n58" class="stm run hide_run"><a href="#n58">58</a></p>
<p id="n59" class="pln"><a href="#n59">59</a></p>
<p id="n60" class="pln"><a href="#n60">60</a></p>
<p id="n61" class="pln"><a href="#n61">61</a></p>
<p id="n62" class="pln"><a href="#n62">62</a></p>
<p id="n63" class="pln"><a href="#n63">63</a></p>
<p id="n64" class="pln"><a href="#n64">64</a></p>
<p id="n65" class="pln"><a href="#n65">65</a></p>
<p id="n66" class="stm mis"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="stm run hide_run"><a href="#n68">68</a></p>
<p id="n69" class="pln"><a href="#n69">69</a></p>
<p id="n70" class="stm mis"><a href="#n70">70</a></p>
<p id="n71" class="pln"><a href="#n71">71</a></p>
<p id="n72" class="stm run hide_run"><a href="#n72">72</a></p>
<p id="n73" class="pln"><a href="#n73">73</a></p>
<p id="n74" class="stm mis"><a href="#n74">74</a></p>
<p id="n75" class="pln"><a href="#n75">75</a></p>
<p id="n76" class="stm run hide_run"><a href="#n76">76</a></p>
<p id="n77" class="pln"><a href="#n77">77</a></p>
<p id="n78" class="pln"><a href="#n78">78</a></p>
<p id="n79" class="stm mis"><a href="#n79">79</a></p>
<p id="n80" class="pln"><a href="#n80">80</a></p>
<p id="n81" class="stm run hide_run"><a href="#n81">81</a></p>
<p id="n82" class="pln"><a href="#n82">82</a></p>
<p id="n83" class="pln"><a href="#n83">83</a></p>
<p id="n84" class="stm mis"><a href="#n84">84</a></p>
<p id="n85" class="pln"><a href="#n85">85</a></p>
<p id="n86" class="stm run hide_run"><a href="#n86">86</a></p>
<p id="n87" class="pln"><a href="#n87">87</a></p>
<p id="n88" class="stm mis"><a href="#n88">88</a></p>
<p id="n89" class="pln"><a href="#n89">89</a></p>
<p id="n90" class="stm run hide_run"><a href="#n90">90</a></p>
<p id="n91" class="pln"><a href="#n91">91</a></p>
<p id="n92" class="pln"><a href="#n92">92</a></p>
<p id="n93" class="pln"><a href="#n93">93</a></p>
<p id="n94" class="stm mis"><a href="#n94">94</a></p>
<p id="n95" class="pln"><a href="#n95">95</a></p>
<p id="n96" class="stm run hide_run"><a href="#n96">96</a></p>
<p id="n97" class="stm run hide_run"><a href="#n97">97</a></p>
<p id="n98" class="stm run hide_run"><a href="#n98">98</a></p>
<p id="n99" class="pln"><a href="#n99">99</a></p>
<p id="n100" class="pln"><a href="#n100">100</a></p>
<p id="n101" class="pln"><a href="#n101">101</a></p>
<p id="n102" class="stm run hide_run"><a href="#n102">102</a></p>
<p id="n103" class="stm run hide_run"><a href="#n103">103</a></p>
<p id="n104" class="stm mis"><a href="#n104">104</a></p>
<p id="n105" class="stm mis"><a href="#n105">105</a></p>
<p id="n106" class="stm run hide_run"><a href="#n106">106</a></p>
<p id="n107" class="stm run hide_run"><a href="#n107">107</a></p>
<p id="n108" class="stm run hide_run"><a href="#n108">108</a></p>
<p id="n109" class="stm run hide_run"><a href="#n109">109</a></p>
<p id="n110" class="stm run hide_run"><a href="#n110">110</a></p>
<p id="n111" class="stm run hide_run"><a href="#n111">111</a></p>
<p id="n112" class="stm run hide_run"><a href="#n112">112</a></p>
<p id="n113" class="stm run hide_run"><a href="#n113">113</a></p>
<p id="n114" class="pln"><a href="#n114">114</a></p>
<p id="n115" class="stm run hide_run"><a href="#n115">115</a></p>
<p id="n116" class="stm mis"><a href="#n116">116</a></p>
<p id="n117" class="stm mis"><a href="#n117">117</a></p>
<p id="n118" class="stm mis"><a href="#n118">118</a></p>
<p id="n119" class="pln"><a href="#n119">119</a></p>
<p id="n120" class="stm run hide_run"><a href="#n120">120</a></p>
<p id="n121" class="stm run hide_run"><a href="#n121">121</a></p>
<p id="n122" class="stm run hide_run"><a href="#n122">122</a></p>
<p id="n123" class="stm mis"><a href="#n123">123</a></p>
<p id="n124" class="stm mis"><a href="#n124">124</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># Copyright (c) 2013-2017 CORE Security Technologies</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Protocol Client Base Class definition</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Author:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#  Alberto Solino (@agsolino)</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com">#  Defines a base class for all clients + loads all available modules</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com"># ToDo:</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="stm run hide_run"><span class="key">import</span> <span class="nam">os</span><span class="op">,</span> <span class="nam">sys</span><span class="op">,</span> <span class="nam">pkg_resources</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="nam">PROTOCOL_CLIENTS</span> <span class="op">=</span> <span class="op">{</span><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="com"># Base class for Protocol Clients for different protocols (SMB, MSSQL, etc)</span><span class="strut">&nbsp;</span></p>
<p id="t23" class="pln"><span class="com"># Besides using this base class you need to define one global variable when</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="pln"><span class="com"># writing a plugin for protocol clients:</span><span class="strut">&nbsp;</span></p>
<p id="t25" class="pln"><span class="com"># PROTOCOL_CLIENT_CLASS = "&lt;name of the class for the plugin>"</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln"><span class="com"># PLUGIN_NAME must be the protocol name that will be matched later with the relay targets (e.g. SMB, LDAP, etc)</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="stm run hide_run"><span class="key">class</span> <span class="nam">ProtocolClient</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="stm run hide_run">    <span class="nam">PLUGIN_NAME</span> <span class="op">=</span> <span class="str">'PROTOCOL'</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">serverConfig</span><span class="op">,</span> <span class="nam">target</span><span class="op">,</span> <span class="nam">targetPort</span><span class="op">,</span> <span class="nam">extendedSecurity</span><span class="op">=</span><span class="key">True</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">serverConfig</span> <span class="op">=</span> <span class="nam">serverConfig</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">targetHost</span> <span class="op">=</span> <span class="nam">target</span><span class="op">.</span><span class="nam">hostname</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="pln">        <span class="com"># A default target port is specified by the subclass</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm mis">        <span class="key">if</span> <span class="nam">target</span><span class="op">.</span><span class="nam">port</span> <span class="key">is</span> <span class="key">not</span> <span class="key">None</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="pln">            <span class="com"># We override it by the one specified in the target</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span> <span class="op">=</span> <span class="nam">target</span><span class="op">.</span><span class="nam">port</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="pln">        <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="stm mis">            <span class="nam">self</span><span class="op">.</span><span class="nam">targetPort</span> <span class="op">=</span> <span class="nam">targetPort</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">target</span> <span class="op">=</span> <span class="nam">target</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">extendedSecurity</span> <span class="op">=</span> <span class="nam">extendedSecurity</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">session</span> <span class="op">=</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">sessionData</span> <span class="op">=</span> <span class="op">{</span><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t43" class="stm run hide_run">    <span class="key">def</span> <span class="nam">initConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t46" class="stm run hide_run">    <span class="key">def</span> <span class="nam">killConnection</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run">    <span class="key">def</span> <span class="nam">sendNegotiate</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">negotiateMessage</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln">        <span class="str">"""</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln"><span class="str">        Charged of sending the type 1 NTLM Message</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t53" class="pln"><span class="str">        :param bytes negotiateMessage:</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="pln"><span class="str">        :return:</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="pln"><span class="str">        """</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm run hide_run">    <span class="key">def</span> <span class="nam">sendAuth</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">authenticateMessageBlob</span><span class="op">,</span> <span class="nam">serverChallenge</span><span class="op">=</span><span class="key">None</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="pln">        <span class="str">"""</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="pln"><span class="str">        Charged of sending the type 3 NTLM Message to the Target</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t62" class="pln"><span class="str">        :param bytes authenticateMessageBlob:</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="pln"><span class="str">        :param bytes serverChallenge:</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="pln"><span class="str">        :return:</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="pln"><span class="str">        """</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm run hide_run">    <span class="key">def</span> <span class="nam">sendStandardSecurityAuth</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">sessionSetupData</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="pln">        <span class="com"># Handle the situation When FLAGS2_EXTENDED_SECURITY is not set</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t72" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getSession</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t73" class="pln">        <span class="com"># Should return the active session for the relayed connection</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getSessionData</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="pln">        <span class="com"># Should return any extra data that could be useful for the SOCKS proxy to work (e.g. some of the</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="pln">        <span class="com"># answers from the original server)</span><span class="strut">&nbsp;</span></p>
<p id="t79" class="stm mis">        <span class="key">return</span> <span class="nam">self</span><span class="op">.</span><span class="nam">sessionData</span><span class="strut">&nbsp;</span></p>
<p id="t80" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t81" class="stm run hide_run">    <span class="key">def</span> <span class="nam">getStandardSecurityChallenge</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t82" class="pln">        <span class="com"># Should return the Challenge returned by the server when Extended Security is not set</span><span class="strut">&nbsp;</span></p>
<p id="t83" class="pln">        <span class="com"># This should only happen with against old Servers. By default we return None</span><span class="strut">&nbsp;</span></p>
<p id="t84" class="stm mis">        <span class="key">return</span> <span class="key">None</span><span class="strut">&nbsp;</span></p>
<p id="t85" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t86" class="stm run hide_run">    <span class="key">def</span> <span class="nam">keepAlive</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t87" class="pln">        <span class="com"># Charged of keeping connection alive</span><span class="strut">&nbsp;</span></p>
<p id="t88" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t89" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t90" class="stm run hide_run">    <span class="key">def</span> <span class="nam">isAdmin</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t91" class="pln">        <span class="com"># Should return whether or not the user is admin in the form of a string (e.g. "TRUE", "FALSE")</span><span class="strut">&nbsp;</span></p>
<p id="t92" class="pln">        <span class="com"># Depending on the protocol, different techniques should be used.</span><span class="strut">&nbsp;</span></p>
<p id="t93" class="pln">        <span class="com"># By default, raise exception</span><span class="strut">&nbsp;</span></p>
<p id="t94" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t95" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t96" class="stm run hide_run"><span class="key">for</span> <span class="nam">file</span> <span class="key">in</span> <span class="nam">pkg_resources</span><span class="op">.</span><span class="nam">resource_listdir</span><span class="op">(</span><span class="str">'impacket.examples.ntlmrelayx'</span><span class="op">,</span> <span class="str">'clients'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t97" class="stm run hide_run">    <span class="key">if</span> <span class="nam">file</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="str">'__'</span><span class="op">)</span> <span class="op">>=</span> <span class="num">0</span> <span class="key">or</span> <span class="nam">file</span><span class="op">.</span><span class="nam">endswith</span><span class="op">(</span><span class="str">'.py'</span><span class="op">)</span> <span class="key">is</span> <span class="key">False</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t98" class="stm run hide_run">        <span class="key">continue</span><span class="strut">&nbsp;</span></p>
<p id="t99" class="pln">    <span class="com"># This seems to be None in some case (py3 only)</span><span class="strut">&nbsp;</span></p>
<p id="t100" class="pln">    <span class="com"># __spec__ is py3 only though, but I haven't seen this being None on py2</span><span class="strut">&nbsp;</span></p>
<p id="t101" class="pln">    <span class="com"># so it should cover all cases.</span><span class="strut">&nbsp;</span></p>
<p id="t102" class="stm run hide_run">    <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t103" class="stm run hide_run">        <span class="nam">package</span> <span class="op">=</span> <span class="nam">__spec__</span><span class="op">.</span><span class="nam">name</span>  <span class="com"># Python 3</span><span class="strut">&nbsp;</span></p>
<p id="t104" class="stm mis">    <span class="key">except</span> <span class="nam">NameError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t105" class="stm mis">        <span class="nam">package</span> <span class="op">=</span> <span class="nam">__package__</span>    <span class="com"># Python 2</span><span class="strut">&nbsp;</span></p>
<p id="t106" class="stm run hide_run">    <span class="nam">__import__</span><span class="op">(</span><span class="nam">package</span> <span class="op">+</span> <span class="str">'.'</span> <span class="op">+</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">splitext</span><span class="op">(</span><span class="nam">file</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t107" class="stm run hide_run">    <span class="nam">module</span> <span class="op">=</span> <span class="nam">sys</span><span class="op">.</span><span class="nam">modules</span><span class="op">[</span><span class="nam">package</span> <span class="op">+</span> <span class="str">'.'</span> <span class="op">+</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">splitext</span><span class="op">(</span><span class="nam">file</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t108" class="stm run hide_run">    <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t109" class="stm run hide_run">        <span class="nam">pluginClasses</span> <span class="op">=</span> <span class="nam">set</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t110" class="stm run hide_run">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t111" class="stm run hide_run">            <span class="key">if</span> <span class="nam">hasattr</span><span class="op">(</span><span class="nam">module</span><span class="op">,</span><span class="str">'PROTOCOL_CLIENT_CLASSES'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t112" class="stm run hide_run">                <span class="key">for</span> <span class="nam">pluginClass</span> <span class="key">in</span> <span class="nam">module</span><span class="op">.</span><span class="nam">PROTOCOL_CLIENT_CLASSES</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t113" class="stm run hide_run">                    <span class="nam">pluginClasses</span><span class="op">.</span><span class="nam">add</span><span class="op">(</span><span class="nam">getattr</span><span class="op">(</span><span class="nam">module</span><span class="op">,</span> <span class="nam">pluginClass</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t114" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t115" class="stm run hide_run">                <span class="nam">pluginClasses</span><span class="op">.</span><span class="nam">add</span><span class="op">(</span><span class="nam">getattr</span><span class="op">(</span><span class="nam">module</span><span class="op">,</span> <span class="nam">getattr</span><span class="op">(</span><span class="nam">module</span><span class="op">,</span> <span class="str">'PROTOCOL_CLIENT_CLASS'</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t116" class="stm mis">        <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t117" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t118" class="stm mis">            <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t119" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t120" class="stm run hide_run">        <span class="key">for</span> <span class="nam">pluginClass</span> <span class="key">in</span> <span class="nam">pluginClasses</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t121" class="stm run hide_run">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">info</span><span class="op">(</span><span class="str">'Protocol Client %s loaded..'</span> <span class="op">%</span> <span class="nam">pluginClass</span><span class="op">.</span><span class="nam">PLUGIN_NAME</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t122" class="stm run hide_run">            <span class="nam">PROTOCOL_CLIENTS</span><span class="op">[</span><span class="nam">pluginClass</span><span class="op">.</span><span class="nam">PLUGIN_NAME</span><span class="op">]</span> <span class="op">=</span> <span class="nam">pluginClass</span><span class="strut">&nbsp;</span></p>
<p id="t123" class="stm mis">    <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t124" class="stm mis">        <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="nam">str</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
